/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var click_status = false,
    deg = 0,
    initial_time = 0;

function rotateArrow(rotary_direction) {

    var interval,
        direction = document.querySelector('#direction');

    //If there is rotary event direction, 'initial_time' will be increase
    if(rotary_direction === "CW" || rotary_direction === "CCW"){
        if(initial_time < 150){
            initial_time = initial_time + 1;
        }
    }
    //If there is not direction, then click event. 'initial_time' will set random
    else {
        initial_time = (Math.random() * 50) + 100;
    }

    if (click_status === false) {
        direction.style.transform = 'rotate(' + deg + 'deg)';
        click_status = true;
        //setInterval each 0.075 sec
        interval = setInterval(function() {
            if ((initial_time--) < 0) {
                clearInterval(interval);
                click_status = false;
            }

            //If rotary_dirction is "CW", then rotate right direction
            if(rotary_direction === "CW"){
                deg = deg + initial_time;
            }
            //If rotary_dirction is "CCW", then rotate left direction
            else{
                deg = deg - initial_time;
            }

            direction.style.transform = 'rotate(' + deg + 'deg)';
        }, 75);
    }
}

window.onload = function () {

    document.addEventListener('tizenhwkey', function(e) {
        if(e.keyName === 'back'){
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (ignore) {
            }
        }
    });


    document.getElementById('direction_button').addEventListener('click', rotateArrow, false);

    document.addEventListener('rotarydetent', function(ev) {
        var direction = ev.detail.direction;
        rotateArrow(direction);
    });
};

